

//------------teleport code by sparky-----------
//---------special effects by TseTse-----------
//---this is where I create the triggers and put them right over the nexus base's
function createNewTeleportTriggers()
{

// get groupid

   $teleportgroup = nametoid(teleporters);

//----get all objects in group------

    %telecount = $teleportgroup.getcount();
       for ( %i = 0; %i < $teleportgroup.getCount(); %i++ )
          {
             %tp = $teleportgroup.getObject( %i );
                %trigger = new Trigger() 
                {
                   dataBlock = NewTeleportTrigger;
                   polyhedron = "-0.75 0.75 0.1 1.5 0.0 0.0 0.0 -1.5 0.0 0.0 0.0 2.3";
                };

            MissionCleanup.add(%trigger);
            %trigger.setTransform(%tp.getTransform());
            %trigger.targetbase = %tp.targetbase;
            %trigger.team = %tp.team;
	        %trigger.motherObj = %tp;     // tag relative object
	        %trigger.sourcebase = %tp;     // tag relative object
            %trigger.message = %tp.message;
            %trigger.logoscale = %tp.logoscale;
            %tp.trigger = %trigger;

            %tp.playThread(1, "ambient");
            %tp.playThread(0, "transition");


            %newHolo = $holoName[%trigger.team] @ "Logo";
            %pos = %trigger.position;

       if(%trigger.logoscale !$= "")
          {
             %holo = new StaticShape()
             {
             rotation = rotfromtransform(%trigger.gettransform());
             position = getWord(%pos,0) @ " " @ getWord(%pos,1) @ " " @ getWord(%pos,2) + 1;
             dataBlock = %newHolo;
             scale = %trigger.logoscale;
             };
      // dump the hologram into MissionCleanup
             MissionCleanup.add(%holo);
      // associate the holo with the projector
          }

  if(%tp.waypoint !$= "")
      {
		%wp =	new WayPoint()
            {
				scale = "1 1 1";
				nameTag = %tp.waypoint;
				dataBlock = "WayPointMarker";
				lockCount = "0";
				homingCount = "0";
				name = %tp.waypoint;
			};

            MissionCleanup.add(%wp);
            %wp.setTransform(%tp.getTransform());
         }
         
         
     }
}

activatePackage(NewTeleport);

datablock TriggerData(NewTeleportTrigger)
{
   tickPeriodMS = 30;
};
//--------------teleporter code here------------------

createNewTeleportTriggers();


package NewTeleport {

function setPlayersPosition2(%data, %obj, %trigger, %colObj)
{
   %vel = getWords(%colObj.getVelocity(), 0, 1) @ " 0";
   if((VectorLen(%vel) < 22) && (%obj.triggeredBy != %colObj))
   {
      %pos = %trigger.position;
      %colObj.setvelocity("0 0 0");
	   %rot = getWords(%colObj.getTransform(),3, 6);
      %colObj.setTransform(getWord(%pos,0) @ " " @ getWord(%pos,1) @ " " @ getWord(%pos,2) + 0.8 @ " " @ %rot);  //center player on object  
      %colObj.setMoveState(true);
//      %colObj.setMoveState(false);
      %colObj.schedule(1300,"setMoveState", false);
      %colObj.schedule(1300,"setvelocity" , "5 5 5");
      return true;
   }
   return false;
}

function NewTeleportTrigger::onEnterTrigger(%data, %trigger, %player)
{
 %colObj = %player;
 if(%trigger.teleporting == "1")
    {
                        %playervelocity = %player.getvelocity();
                        %xv = getword(%playervelocity, 0);
		                %yv = getword(%playervelocity, 1);
                        %zv = getword(%playervelocity, 2);

                            if(getSubStr(%xv,0,1) !$= "-")
                            %xv = "-" @ %xv + 4;
                            else
                               %xv = getsubstr(%xv,1,strlen(%xv - 1)) + 4;

                            if(getSubStr(%yv,0,1) !$= "-")
                            %yv = "-" @ %yv + 4;
                            else
                               %yv = getsubstr(%yv,1,strlen(%yv - 1)) + 4;

                            if(getSubStr(%zv,0,1) !$= "-")
                            %zv = "-" @ %zv + 4;
                            else
                               %zv = getsubstr(%zv,1,strlen(%zv - 1)) + 4;


                       %player.setVelocity(%xv SPC %yv SPC %zv );
    messageClient(%Player.client, 'MsgClient', "\c0Teleporter in use.");
//    %player.setvelocity("1 1 1");
    return;
    }


  if(%player.transported $= "1")  // if this player was just transported
   {
   %player.transported = "0";
   return; // then get out or it will never stop
   }

              if(%player.team != %trigger.team)
                   {
                     if(%trigger.team != 0)
                       {
                        %playervelocity = %player.getvelocity();
                        %xv = getword(%playervelocity, 0);
		                %yv = getword(%playervelocity, 1);
                        %zv = getword(%playervelocity, 2);

                            if(getSubStr(%xv,0,1) !$= "-")
                            %xv = "-" @ %xv + 4;
                            else
                               %xv = getsubstr(%xv,1,strlen(%xv - 1)) + 4;

                            if(getSubStr(%yv,0,1) !$= "-")
                            %yv = "-" @ %yv + 4;
                            else
                               %yv = getsubstr(%yv,1,strlen(%yv - 1)) + 4;

                            if(getSubStr(%zv,0,1) !$= "-")
                            %zv = "-" @ %zv + 4;
                            else
                               %zv = getsubstr(%zv,1,strlen(%zv - 1)) + 4;


                       %player.setVelocity(%xv SPC %yv SPC %zv );
                        messageClient(%Player.client, 'MsgClient', "\c0Wrong team.");
                        return;
                        }
                    }

        setPlayersPosition2(%data, %obj, %trigger, %colObj);




//      nametoid(%trigger.targetbase).setThreadDir(1, %trigger.targetbase.flashThreadDir);


           %player.transported = "1";

           if(%trigger.message !$= "")
      	           messageClient(%Player.client, 'MsgClient', "\c0 " @ %trigger.message);

           %rot = rotFromTransform( %player.getTransform() );
           %player.setCloaked(true);
           teleporteffect(posfromtransform(%player.gettransform()));
           %pos = posFromTransform( nametoid(%trigger.targetbase).getTransform() );

		%x = getword(%pos, 0); 			// left of center
		%y = getword(%pos, 1);			// "forward" adjustment
		%z = getword(%pos, 2) + 1.6; 		// VERTICLE
		%exitpos = %x SPC %y SPC %z;		// new position
           teleporteffect(%exitpos);
           %trigger.teleporting = "1";
           %player.sourcetrigger = %trigger;
           %player.schedule(500, "settransform", %exitpos @ " " @ %rot);
           %player.schedule(500, "setCloaked", false);
//           %player.setvelocity("5 5 5");




//-----hope this works?!?!?--------------------------------------------------


}

function NewTeleportTrigger::onleaveTrigger(%data, %trigger, %player)
{
if(%player.sourcetrigger != %trigger)
      %player.sourcetrigger.teleporting = "0";
      

      
      
      
 echo(%trigger.motherObj);
 echo(nametoid(%trigger.targetbase));
// echo(%player);
}

function NewTeleportTrigger::onTickTrigger(%data, %obj)
{
   Game.onTickTrigger(%obj.name, %data, %obj);
}

function teleporteffect(%position)
{
//       for ( %i = 0; %i < 4 %i++ )
//   {
           %pos = %position;
echo("the object is number " @ %obj );

	%effect1 = new ParticleEmissionDummy()
            {
		       position = %pos;
		       rotation = "1 0 0 0";
         		scale = "1 1 1";
         		dataBlock = "doubleTimeEmissionDummy";
         		lockCount = "0";
         		homingCount = "0";
         		emitter = "AABulletExplosionEmitter2";
         		velocity = "1";
         	};
	%effect2 = new ParticleEmissionDummy()
            {
		       position = getWord(%pos,0) @ " " @ getWord(%pos,1) @ " " @ getWord(%pos,2) + 0.5;
		       rotation = "1 0 0 0";
         		scale = "1 1 1";
         		dataBlock = "doubleTimeEmissionDummy";
         		lockCount = "0";
         		homingCount = "0";
         		emitter = "AABulletExplosionEmitter2";
         		velocity = "1";
         	};
	%effect5 = new ParticleEmissionDummy()
            {
		       position = getWord(%pos,0) @ " " @ getWord(%pos,1) @ " " @ getWord(%pos,2) + 0.75;
		       rotation = "1 0 0 0";
         		scale = "1 1 1";
         		dataBlock = "doubleTimeEmissionDummy";
         		lockCount = "0";
         		homingCount = "0";
         		emitter = "flareEmitter";
         		velocity = "1";
         	};

	%effect3 = new ParticleEmissionDummy()
            {
		       position = getWord(%pos,0) @ " " @ getWord(%pos,1) @ " " @ getWord(%pos,2) + 1;
		       rotation = "1 0 0 0";
         		scale = "1 1 1";
         		dataBlock = "doubleTimeEmissionDummy";
         		lockCount = "0";
         		homingCount = "0";
         		emitter = "AABulletExplosionEmitter2";
         		velocity = "1";
         	};
	%effect4 = new ParticleEmissionDummy()
            {
		       position = getWord(%pos,0) @ " " @ getWord(%pos,1) @ " " @ getWord(%pos,2) + 1.5;
		       rotation = "1 0 0 0";
         		scale = "1 1 1";
         		dataBlock = "doubleTimeEmissionDummy";
         		lockCount = "0";
         		homingCount = "0";
         		emitter = "AABulletExplosionEmitter2";
         		velocity = "1";
         	};
            MissionCleanup.add(%effect1);
            MissionCleanup.add(%effect2);
            MissionCleanup.add(%effect3);
            MissionCleanup.add(%effect4);
            MissionCleanup.add(%effect5);
            %effect5.schedule(500, "delete");
            %effect1.schedule(2000, "delete");
            %effect2.schedule(2000, "delete");
            %effect3.schedule(2000, "delete");
            %effect4.schedule(2000, "delete");

}


};
//Teleport code ends here----------------------------------------


